;;;
;;;
;;; File:         sgi-midi.lisp
;;;
;;; Summary:      
;;;
;;; Author:       Tobias Kunze
;;; e-Mail:       t@kunze.stanford.edu
;;; Org:          CCRMA, Stanford University
;;;
;;; orig-Date:    11-Jul-96 at 21:54:42
;;; Last-Mod:     16-Jul-96 at 21:12:54 by Tobias Kunze
;;;
;;; Revision:     
;;;
;;; Description:  % cc -c -KPIC sgi-midi.c 
;;;               % ld -shared -all -o sgi-midi.so sgi-midi.o
;;;
;;; Changes:
;;;   00-Jan-96   tk 


(in-package :cm)

#+cm 
(defun %midi-default-channel-map (port)
  (declare (ignore port))
  (default-midi-channel-map))


#+excl
(progn

  (require :foreign)

  (ff:defun-c-callable %midi-read-hook% ((event :fixnum) (time :fixnum))
		       (declare (special *midi-read-hook*) 
				(optimize (speed 3) (safety 0)))
		       (when *midi-read-hook*
			 (funcall (the function *midi-read-hook*)
				  (the fixnum event) (the fixnum time))))

  (defparameter %midi-read-hook-callback-ptr%
    (nth-value 1 (ff:register-function '%midi-read-hook%)))
  
  (defun %midi-open (port) (%%midi-open port %midi-read-hook-callback-ptr%))

  (ff:defforeign '%%midi-open :entry-point "MidiOpen__FiPFlT1_v"
		 :prototype t :arg-checking nil :arguments '(fixnum bignum)
		 :return-type :fixnum)
  (ff:defforeign '%midi-close :entry-point "MidiClose__Fv"
		 :arg-checking nil :arguments '() :return-type :fixnum)

  (ff:defforeign '%midi-start-time :entry-point "MidiStartTime__Fv"
		 :arg-checking nil :arguments '() :return-type :fixnum)
  (ff:defforeign '%midi-stop-time :entry-point "MidiStopTime__Fv"
		 :arg-checking nil :arguments '() :return-type :fixnum)
  (ff:defforeign '%midi-get-time :entry-point "MidiGetTime__Fv"
		 :arg-checking nil :arguments '() :return-type :fixnum)
  (ff:defforeign '%midi-set-time :entry-point "MidiSetTime__Fl"
		 :arg-checking nil :prototype t :arguments '(fixnum)
		 :return-type :fixnum)

  (ff:defforeign '%midi-read-messages :entry-point "MidiReadMessages__Fv"
		 :arg-checking nil :arguments '() :return-type :fixnum)
  (ff:defforeign '%midi-write-message :entry-point "MidiWriteMessage__FlT1"
		 :arg-checking nil :prototype t :arguments '(fixnum fixnum)
		 :return-type :fixnum)
  #|
  (ff:defforeign '%midi-write-message :entry-point "MidiWriteNote__FlN21"
		 :arg-checking nil :prototype t
		 :arguments '(fixnum fixnum fixnum)
		 :return-type :fixnum)
  |#
  (ff:defforeign '%midi-flush-transmit :entry-point "MidiFlushTransmit__Fv"
		 :arg-checking nil :arguments '() :return-type :fixnum)
  (ff:defforeign '%midi-flush-receive :entry-point "MidiFlushReceive__Fv"
		 :arg-checking nil :arguments '() :return-type :fixnum)
  (ff:defforeign '%midi-hush :entry-point "MidiHush__Fv"
		 :arg-checking nil :arguments '() :return-type :fixnum)	       
  (ff:defforeign '%midi-all-notes-off :entry-point "MidiAllNotesOff__Fl" 
		 :prototype t :arg-checking nil :arguments '(fixnum)
		 :return-type :fixnum)
  )

;;;
;;; -*- EOF -*-

